/*

	Written by:	Mark Krueger

	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

*/

#define COURIER


#ifdef	COURIER

#define	BASE_LINE	8
#define	FONT_ID		22		
#define	FONT_SIZE	10
#define	FONT_HEIGHT	10
#define	FONT_WIDTH	8
#define	CODEC_NAME	"\pCourier"

#else

	// Monaco
	
#define	BASE_LINE	7
#define	FONT_ID		4		
#define	FONT_SIZE	12
#define	FONT_HEIGHT	12
#define	FONT_WIDTH	8
#define	CODEC_NAME	"\pMonaco"

#endif


/* This is the structure we use to hold data used by all instances of
   this compressor and decompressor */

typedef struct	{					
	CodecInfo	**info;					/* our cached codec info structure */
	GWorldPtr	tableWorld;
	char		*table;
	Boolean		skipTable[256];			// not used 
} SharedGlobals;


/* This is the structure we use to store our global data for each instance */

typedef struct	{						
	SharedGlobals	*sharedGlob;		/* pointer to instance-shared globals */
	long		totalSize;
	ComponentInstance self;
} Globals;
